"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("rxjs/add/operator/map");
function routeDecoratorFactory(routePropertyName) {
    return function (annotation, config) {
        return function (target, key, index) {
            var ngOnInit = target.ngOnInit;
            target.ngOnInit = function () {
                var parent = this.route, routePropertyValue = null;
                var _loop_1 = function () {
                    var targetKeyName = annotation || key.replace(/\$$/, '');
                    routePropertyValue = parent[routePropertyName].map(function (d) { return d[targetKeyName]; });
                    parent = parent.parent;
                };
                while (parent && !routePropertyValue) {
                    _loop_1();
                }
                if (config && !config.observable) {
                    routePropertyValue.subscribe(function (val) { return target[key] = val; });
                }
                else {
                    target[key] = routePropertyValue;
                }
                delete this.ngOnInit;
                if (ngOnInit) {
                    ngOnInit.call(this);
                    this.ngOnInit = ngOnInit;
                }
            };
        };
    };
}
exports.routeDecoratorFactory = routeDecoratorFactory;
